DIM X1(0:35) AS shared INTEGER: DIM X2(0:35) AS shared INTEGER
DIM X3(0:35) AS shared INTEGER: DIM Y1(0:35) AS shared INTEGER
DIM Y2(0:35) AS shared INTEGER: DIM Y3(0:35) AS shared INTEGER
DIM X AS shared SINGLE: DIM Y AS shared SINGLE
DIM AntriebX(0 TO 35) AS shared SINGLE
DIM AntriebY(0 TO 35) AS shared SINGLE
DIM AsteroidX(1 TO 10) AS shared INTEGER   'Datenfelder fr insgesamt 10
DIM AsteroidY(1 TO 10) AS shared INTEGER   'Asteroiden - Koordinaten sowie
DIM AsteroidXc(1 TO 10) AS shared INTEGER  'deren Vernderungen, die Geschwin-
DIM AsteroidYc(1 TO 10) AS shared INTEGER  'igkeit und Richtung bestimmen
DIM Zeit AS shared LONG: DIM Punkte AS shared INTEGER
DIM LName(1 TO 10) as shared string:DIM LPunkte(1 TO 10) AS shared INTEGER
DIM ScheibeX AS shared INTEGER:DIM ScheibeY AS shared INTEGER
shared SoLow

DECLARE SUB Bestenliste ()
DECLARE SUB Berechnen ()
DECLARE SUB Malen (X AS SINGLE, Y AS SINGLE, F AS INTEGER, W AS INTEGER)
DECLARE SUB Spiel ()
DECLARE SUB AsteroidBewegen ()
DECLARE SUB EndedesSpiels ()

RANDOMIZE TIMER

CALL Berechnen

SCREEN 7: CLS : COLOR 2: LOCATE 13, 9: PRINT "Asteroids starten? (j/n)"
while 1
 SELECT CASE INKEY$
  CASE "j","J",CHR$(13)
    CLS:Punkte% = 0
    FOR g%=1 TO 10
      AsteroidX(g%)=INT(RND * 320): AsteroidY(g%) = INT(RND * 200)
      AsteroidXc(g%) = INT(RND * 5) - 2: AsteroidYc(g%) = INT(RND * 5) - 2
      CIRCLE (AsteroidX(g%), AsteroidY(g%)),1,2
    NEXT
    ScheibeX = INT(RND * 320): ScheibeY = INT(RND * 200)
    CIRCLE (ScheibeX, ScheibeY),10,12
    PAINT (ScheibeX, ScheibeY),14,12
    COLOR 15: Zeit = TIMER: CALL Spiel
    CLS : COLOR 2: LOCATE 13, 12: PRINT "Noch einmal? (j/n)"
  CASE "n", "N", CHR$(27): SCREEN 0: COLOR 7, 0: CLS:END
  CASE ELSE
 END SELECT
wend

SUB AsteroidBewegen
FOR g% = 1 TO 10
   CIRCLE (AsteroidX(g%), AsteroidY(g%)),1,0

   AsteroidX(g%) = AsteroidX(g%) + AsteroidXc(g%)
   IF AsteroidX(g%) > 320 THEN AsteroidX(g%) = 0
   IF AsteroidX(g%) < 0 THEN AsteroidX(g%) = 320

   AsteroidY(g%) = AsteroidY(g%) + AsteroidYc(g%)
   IF AsteroidY(g%) > 200 THEN AsteroidY(g%) = 0
   IF AsteroidY(g%) < 0 THEN AsteroidY(g%) = 200

   CIRCLE (AsteroidX(g%), AsteroidY(g%)),1,2

   IF ABS(AsteroidX(g%) - X) < 5 AND ABS(AsteroidY(g%) - Y) < 5 THEN
     IF SoLow + .5 < TIMER THEN SOUND 700, .5: Zeit = Zeit - 10: SoLow = TIMER
   END IF
NEXT
END SUB

SUB Berechnen
ZwoPI# = 8 * ATN(1): ZehnGrad# = ZwoPI# / 36
FOR W% = 0 TO 35
    Radiant# = W% * ZehnGrad#: SinusRadiant# = SIN(Radiant#)
    CosinusRadiant# = COS(Radiant#): X1(W%) = 6 * SinusRadiant#
    X2(W%) = 3 * CosinusRadiant# - 6 * SinusRadiant#
    X3(W%) = -3 * CosinusRadiant# - 6 * SinusRadiant#
    Y1(W%) = -6 * CosinusRadiant#
    Y2(W%) = 3 * SinusRadiant# + 6 * CosinusRadiant#
    Y3(W%) = -3 * SinusRadiant# + 6 * CosinusRadiant#
    AntriebX(W%) = SinusRadiant#: AntriebY(W%) = CosinusRadiant#
NEXT
END SUB

SUB Bestenliste
OPEN "Asteroid.bst" FOR INPUT AS #1
INPUT #1, NichtZuGebrauchen$
FOR n = 1 TO 10
  INPUT #1, LName$(n)
  INPUT #1, LPunkte(n)
NEXT
CLOSE #1
CLS
IF Punkte > LPunkte(10) THEN
  CIRCLE (160, 100), 157, 119, , , .62
  PAINT (0, 0), 96, 119
  CIRCLE (160, 100), 158, 2, , , .62
  CIRCLE (160, 100), 159, 10, , , .62
  COLOR 40: LOCATE 8, 15: PRINT "GRATULATION"
  COLOR 20: LOCATE 15, 18: PRINT ""
  LOCATE 16, 10: PRINT "(Bitte nur 10 Zeichen)";
  COLOR 3: LOCATE 10, 6: PRINT "Sie sind unter den zehn Besten."
  LOCATE 11, 11: PRINT "Sie haben"; Punkte; "Punkte"
  LOCATE 12, 2: PRINT "Jetzt knnen Sie Ihren Namen eingeben."
  LOCATE 14, 13: LINE INPUT "Name:"; MeinName$
  IF MeinName$ = "" THEN GOTO 942
  MeinName$ = MID$(MeinName$, 1, 10)
  LPunkte(10) = Punkte: LName$(10) = MeinName$
  FOR V% = 9 TO 1 STEP -1
    IF Punkte > LPunkte(V%) THEN
      LPunkte(V% + 1) = LPunkte(V%): LName$(V% + 1) = LName$(V%)
      LPunkte(V%) = Punkte: LName$(V%) = MeinName$
    ELSE
      EXIT FOR
    END IF
  NEXT
END IF

OPEN "Asteroid.bst" FOR OUTPUT AS #1
WRITE #1, NichtZuGebrauchen$
FOR n = 1 TO 10
  WRITE #1, LName$(n)
  WRITE #1, LPunkte(n)
NEXT
CLOSE #1

942 CLS : CIRCLE (160, 100), 157, 4, , , .62: PAINT (0, 0), 89, 4
CIRCLE (160, 100), 158, 40, , , .62: CIRCLE (160, 100), 159, 12, , , .62
COLOR 11: LOCATE 6, 14: PRINT "Die besten Zehn": COLOR 3
FOR n = 1 TO 10
  IF n = 10 THEN
    LOCATE n + 7, 10: PRINT n; "- "; LName$(n);
  ELSE
    LOCATE n + 7, 11: PRINT n; "- "; LName$(n);
  END IF
  LOCATE n + 7, 27: PRINT LPunkte(n);
NEXT
COLOR 8: LOCATE 20, 15: PRINT "Taste drcken";
WHILE INKEY$ = "": WEND
END SUB

SUB EndedesSpiels
COLOR 15: LOCATE 13, 16: PRINT "Esc drcken";
WHILE INKEY$ <> CHR$(27): WEND
def seg
CALL Bestenliste
END SUB

SUB Malen (X AS SINGLE, Y AS SINGLE, F AS INTEGER, W AS INTEGER)
X1% = X + X1(W): X2% = X + X2(W): X3% = X + X3(W)
Y1% = Y + Y1(W): Y2% = Y + Y2(W): Y3% = Y + Y3(W)

IF POINT(X1%, Y1%)=14 THEN
   LINE (ScheibeX - 10, ScheibeY - 10)-(ScheibeX + 10, ScheibeY + 10), 0, BF
   Punkte = Punkte + 10: Zeit = Zeit + 5
   ScheibeX = INT(RND * 320): ScheibeY = INT(RND * 200)
   CIRCLE (ScheibeX, ScheibeY),10,12
   PAINT (ScheibeX, ScheibeY),14,12
END IF

LINE (X1%, Y1%)-(X2%, Y2%), F: LINE -(X3%, Y3%), F: LINE -(X1%, Y1%), F
END SUB

SUB Spiel
X = 160: Y = 100
DEF SEG = &H40
TastaturStatus% = PEEK(&H17)

CALL Malen(X, Y, 11, W%)
LOCATE 1, 1: PRINT INT(Zeit - TIMER) + 200, "Punkte :"; Punkte
WHILE INKEY$ = "": WEND

WHILE I$ <> CHR$(27)
 CALL AsteroidBewegen
 I$ = INKEY$
 IF I$ = CHR$(13) THEN xc = xc - AntriebX(W%): yc = yc - AntriebY(W%)
 yc = yc * .99: xc = xc * .99
 IF yc > 9 THEN yc = 9
 IF xc > 9 THEN xc = 9
 IF yc < -9 THEN yc = -9
 IF xc < -9 THEN xc = -9
 Y = Y + yc: X = X - xc
 IF Y > 200 THEN Y = 0
 IF Y < 0 THEN Y = 200
 IF X < 0 THEN X = 320
 IF X > 320 THEN X = 0
 CALL Malen(AltX, AltY, 0, AltW%)
 IF PEEK(&H17) = TastaturStatus% + 1 THEN W% = W% + 1: IF W% = 36 THEN W% = 0
 IF PEEK(&H17) = TastaturStatus% + 2 THEN W% = W% - 1: IF W% = -1 THEN W% = 35
 CALL Malen(X,Y,11,W%)
 delay .05
 AltX = X: AltY = Y: AltW% = W%
 IF Durchlauf% = 5 THEN
   LOCATE 1, 1: PRINT INT(Zeit - TIMER) + 200, "Punkte :"; Punkte
   CIRCLE (ScheibeX, ScheibeY),10,12
   PAINT (ScheibeX, ScheibeY),14,12
   IF INT(Zeit - TIMER) + 200 < 0 THEN CALL EndedesSpiels: EXIT SUB
   Durchlauf% = 0
  ELSE
   incr Durchlauf%
 END IF
WEND
def seg
END SUB