DEFINT A-Z
RANDOMIZE TIMER

screen 11:reg 1,&H0013:call interrupt &H10:def seg=&HA000

SetPal 0
CALL subdivide(0, 0, 319, 199)
WHILE INKEY$ = ""
  SetPal (j)
  incr j
  delay .1
WEND

SCREEN 0:def seg

SUB newcol (xa, ya, x, y, xb, yb)
  col=ABS(xa - xb) + ABS(ya - yb)
  col=RND*2*col-col
  col=(col+peek(ya*320+xa)+peek(yb*320+xb))\2
  IF col<1 THEN col=1
  IF col>180 THEN col=1
  IF peek(y*320+x)=0 THEN poke y*320+x,col
END SUB

SUB SetPal (j)
  FOR i = 1 TO 63
    CALL setrgb(i + j, 0, 63 - i, i)
    CALL setrgb(i + 63 + j, i, 0, 63 - i)
    CALL setrgb(i + 126 + j, 63 - i, i, 0)
  NEXT
END SUB

SUB setrgb (nr, r, g, b)
  OUT &H3C8, nr
  OUT &H3C9, r
  OUT &H3C9, g
  OUT &H3C9, b
END SUB

SUB subdivide (x1, y1, x2, y2)
  IF NOT (x2-x1<2 AND y2-y1<2) THEN
    x = (x1+x2) \ 2
    y = (y1+y2) \ 2
    newcol x1,y1,x,y1,x2,y1
    newcol x2,y1,x2,y,x2,y2
    newcol x1,y2,x,y2,x2,y2
    newcol x1,y1,x1,y,x1,y2
    col=peek(y1*320+x1)+peek(y1*320+x2)+peek(y2*320+x2)+peek(y2*320+x1)
    col=col\4
    poke y*320+x,col
    subdivide x1, y1, x, y
    subdivide x, y1, x2, y
    subdivide x, y, x2, y2
    subdivide x1, y, x, y2
  END IF
END SUB