 '--- Ausstattung des Rechners
 %Equipment   = &H208  ' 2 bytes  Ausstattungsliste (siehe auch BIOS-INT11)
 '
 '   76543210 - niederwertiges Byte (Low)
 '            Diskettenlaufwerke vorhanden
 '           mathematischer Coprozessor (80x87) vorhanden
 '         bei alten PC-Systemen: RAM-Gre (00=16kB, 11=64kB)
 '          Maus oder anderes Zeigegert installiert (nur bei PS2)
 '         bei PS2 nicht benutzt
 '       Videomodus (01=40x25 Farbe, 10=80x25 Farbe, 11=80x25 Mono)
 '     Anzahl der installierten Diskettenlaufwerke (beginnt bei 0)
 '
 '   76543210 - hherwertiges Byte (High)
 '            nicht benutzt
 '         Anzahl der seriellen Schnittstellen
 '        Game-Port vorhanden
 '       internes Modem (nur bei PS2 und XT)
 '     Anzahl der parallelen Schnittstellen
 '
 %HDStatus    = &H23A  ' (hherwert. Byte) Status der letzten Festplatten-
                       ' operation  (siehe auch %DiskOps)
                       ' (niederwert. Byte) Anzahl der installierten Fest-
                       ' platten
 DIM ABSOLUTE BIOS(&H300) AS INTEGER AT 0

 COLOR 14,1
 CLS
 ?"HDs:";bits?(bios(%HDStatus))+1
 g??=bios(%Equipment)
 ?"Disk?:";bit(g??,0)
 ?"Disketten:";(g?? and &B11000000)\64+1
 ?"Coprozessor?:";bit(g??,1)
 ?"LPTs:";(g?? and &B1100000000000000)\16384
 ?"COMs:";(g?? and &B111000000000)\512