setvideomode &H13
call writestring(25,1,str$(pbvscrnmode),15)
while inkey$=""
  setbioscript fix(rnd*3)+1
  call writestring(fix(rnd*11)+1,fix(rnd*35)+1,"Test",fix(rnd*14)+1)
wend
screen 0:def seg

sub SetVideoMode(m?)
  reg 1,m?
  call interrupt &H10
end sub

sub PutPixel(x%,y%,f?)
  reg 1,256*&H0C+f?
  reg 2,0
  reg 3,x%
  reg 4,y%
  call interrupt &H10
end sub

sub SetBioscript(s?)
  select case s?
    case 1:reg 1,&H11*256+&H23:reg 4,60
    case 2:reg 1,&H11*256+&H22:reg 4,43
    case else:reg 1,&H11*256+&H24:reg 4,30
  end select
  reg 2,0:call interrupt &H10
end sub

sub writeChar(z?,f?)
  reg 1,256*&H0E+z?
  reg 2,f?
  call interrupt &H10
end sub

sub putChar(z?,f?)
  reg 1,256*&H09+c?
  reg 2,f?
  reg 3,1
  call interrupt &H10
end sub

sub go(x%,y%)
  reg 1,512 : reg 2,0 : reg 4,(x%-1)*256+y%-1		'Register einstellen.
  call interrupt &H10					'Interrupt-Aufruf
end sub

sub VPosition(x%,y%)					'Ers. POS und CSRLIN
  reg 1,768 : reg 2,0					'Register einstellen.
  call interrupt &H10					'Interrupt-Aufruf
  x%=(reg(4) and &HFF00)/256+1				'Register fr x- und
  y%=(reg(4) and &H00FF)+1				'y-Position lesen.
end sub

sub VLiesASCII(z%,f%)					'Ersetzt SCREEN()
  reg 1,2048 : reg 2,0                                  'Register einstellen.
  call interrupt &H10					'Interrupt-Aufruf
  f%=(reg(1) and &HFF00)/256				'Register fr Farbe
  z%=(reg(1) and &H00FF)				'und Zeichen lesen.
end sub

sub printString(z%,n%,f%)
  if n%<1 then n%=1					'Lnge prfen.
  reg 1,2560+z% : reg 2,f% : reg 3,n%			'Register einstellen
  call interrupt &H10
end sub

sub writeString(x%,y%,kette$,f%)
  reg 1,4865 : reg 2,f%
  reg 3,len(kette$) : reg 4,(x%-1)*256+(y%-1)
  reg 7,strptr(kette$) : reg 9,strseg(kette$)
  call interrupt &H10
end sub